#pragma once
#include "Data_types.h"

class MeshLoader {
protected:
	std::vector<Node> m_Node;
	std::vector<FiniteElement> m_FiniteElement;
	std::vector<BoundaryFiniteElement> m_BoundaryFiniteElement;

public:
	virtual void loadMesh(const std::string&)=0;
	
	virtual ~MeshLoader() = default; //!!! Почему деструктор не виртуальный?

	std::vector<Node>& vector_Node();
	std::vector<FiniteElement>& vector_FiniteElement();
	std::vector<BoundaryFiniteElement>& vector_BoundaryFiniteElement();

	std::vector<int> FiniteElementByThreeNodes(int, int, int);
	std::vector<int> FiniteElementByTwoNodes(int id1, int id2);

	std::set<int> BoundaryNodes(int id);
	std::set<int> ContainerKE_by_id_border(int id_border);
	std::vector<int> BoundaryKE(int id);

	void NewNodes();

	std::vector<std::set<int>> Container_of_containers_of_neighboring_nodes();

	void print_Node();
	void print_FiniteElement();
	void print_BoundaryFiniteElement();

	FiniteElement& operator[](int);
};

